<?php 
/* 
 * PHP-Teleinfo - script d'acqusition 
 * v.0.1.5 
 * 
 * Utilisation : 
 *  /usr/bin/php /var/www/dom/teleinfo/log.php >> /opt/dom/teleinfo.csv 
 *  
 *  Pour creer le fichier CSV : 
 *    /usr/bin/php /var/www/dom/teleinfo/log.php --header > /opt/dom/teleinfo.csv 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 * 
 *  This program is distributed in the hope that it will be useful, 
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *  GNU General Public License for more details. 
 * 
 *  You should have received a copy of the GNU General Public License 
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. 
 * 
 *  (c) 2007 Radim BADSI <info AT devbay DOT fr> 
 */ 

/* Liste des messages a sauvegarder */ 
$messages = array("EJPHN","EJPHPM","PAPP","PTEC","IINST1","IINST2","IINST3"); 
/* Nombres d'essais maximum */ 
$jmax = 10; 

/* Chemin d'acces a la bibliotheque PHP-Teleinfo */ 
$phpteleinfo_path = "teleinfo.php"; 


if ($argv[1] == "--header") { 
   $csv = chr(34) . "Date" . chr(34) . ","; 
   /* Generer l'en-tete */ 
   foreach($messages as $etiquette) { 
      $csv .= chr(34) . $etiquette . chr(34) . ","; 
   } 

} else { 
   /* Lire les messages */ 
   include ($phpteleinfo_path); 
    
   $j = 0; // Nombre d'essais 
   do { 
      $csv = chr(34) . time() . chr(34) . ","; 
      $valid_etiq = 0; // Nombre d'etiquettes valides recuperees 
      sleep(2); // Attendre 1s avant chaque tentative 
      $trame = teleinfo(); 
      foreach ($messages as $etiquette) { 
         if ($trame[$etiquette]) { 
            $valid_etiq++; 
            $csv .= chr(34) . $trame[$etiquette] . chr(34) . ","; 
         } 
         $j++; // Incrementer le nombre d'essais 
         if ($j >= $jmax) die(); 
      }    
   } while ($valid_etiq != count($messages)); 
} 
/* Remplacer la derniere virgule par un saut a la ligne */ 
$csv = substr_replace($csv, "\n", -1, 1); 


/* Afficher le CSV */ 
##echo($csv); 

$csv2=chop($csv);

$table=array();
$table=explode(",",$csv2);

mysql_connect('localhost','root','xxx'); 
mysql_select_db('edf');

if ($table[1]!='')
{
$res = mysql_query("INSERT INTO conso (id,Date,EJPHN,EJPHPM,PAPP,PTEC,IINST1,IINST2,IINST3) VALUES ('0',$table[0],$table[1],$table[2],$table[3],$table[4],$table[5],$table[6],$table[7])");
}

mysql_close();


?>
