<?php 
/* 
 * PHP-Teleinfo 
 * v.0.2 
 * 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 * 
 *  This program is distributed in the hope that it will be useful, 
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *  GNU General Public License for more details. 
 * 
 *  You should have received a copy of the GNU General Public License 
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. 
 * 
 *  (c) 2008 Radim BADSI <info AT devbay DOT fr> 
 */ 

/* Definition des messages */ 
function mesdef() { 
   $trame_def = array(); 
   $trame_def["OPTARIF"] = array( 
                     "size"=>4, 
                     "desc"=>"type d'abonnement", 
                     "unit"=>"" 
                     ); 
    
   $trame_def["ADCO"] = array( 
                     "size"=>12, 
                     "desc"=>"numro srie compteur", 
                     "unit"=>"" 
                     ); 
   $trame_def["ISOUSC"] = array( 
                     "size"=>2, 
                     "desc"=>"intensit souscrite", 
                     "unit"=>"A" 
                     ); 
                      
   $trame_def["BASE"] = array( 
                     "size"=>9, 
                     "desc"=>"index (base)", 
                     "unit"=>"Wh" 
                     ); 
                      
   $trame_def["HCHC"] = array( 
                     "size"=>9, 
                     "desc"=>"index (heures creuses)", 
                     "unit"=>"Wh" 
                     ); 
                      
   $trame_def["HCHP"] = array( 
                     "size"=>9, 
                     "desc"=>"index (heures pleines)", 
                     "unit"=>"Wh" 
                     ); 
                      
   $trame_def["EJPHN"] = array( 
                     "size"=>9, 
                     "desc"=>"index (normal EJP)", 
                     "unit"=>"Wh" 
                     ); 
    
   $trame_def["EJPHPM"] = array( 
                     "size"=>9, 
                     "desc"=>"index (pointe mobile EJP)", 
                     "unit"=>"Wh" 
                     ); 
                      
   $trame_def["BBR HC JB"] = array( 
                     "size"=>9, 
                     "desc"=>"index (heures creuses jours bleus Tempo)", 
                     "unit"=>"Wh" 
                     ); 
                      
   $trame_def["BBR HP JB"] = array( 
                     "size"=>9, 
                     "desc"=>"index (heures pleines jours bleus Tempo)", 
                     "unit"=>"Wh" 
                     ); 
    
   $trame_def["BBR HC JW"] = array( 
                     "size"=>9, 
                     "desc"=>"index (heures creuses jours blancs Tempo)", 
                     "unit"=>"Wh" 
                     ); 
                      
   $trame_def["BBR HP JW"] = array( 
                     "size"=>9, 
                     "desc"=>"index (heures pleines jours blancs Tempo)", 
                     "unit"=>"Wh" 
                     ); 
                      
   $trame_def["BBR HC JR"] = array( 
                     "size"=>9, 
                     "desc"=>"index (heures creuses jours rouges Tempo)", 
                     "unit"=>"Wh" 
                     ); 
                      
   $trame_def["BBR HP JR"] = array( 
                     "size"=>9, 
                     "desc"=>"index (heures pleines jours rouges Tempo)", 
                     "unit"=>"Wh" 
                     ); 
                      
   $trame_def["PEJP"] = array( 
                     "size"=>2, 
                     "desc"=>"pravis priode EJP", 
                     "unit"=>"" 
                     ); 
                      
   $trame_def["PTEC"] = array( 
                     "size"=>4, 
                     "desc"=>"priode tarifaire en cours", 
                     "unit"=>"" 
                     ); 
    
   $trame_def["DEMAIN"] = array( 
                     "size"=>1, 
                     "desc"=>"couleur du lendemain (Tempo)", 
                     "unit"=>"" 
                     ); 
                      
   $trame_def["ADIR1"] = array( 
                     "size"=>3, 
                     "desc"=>"avertissement dpassement ", 
                     "unit"=>"A" 
                     ); 
   $trame_def["ADIR2"] = array( 
                     "size"=>3, 
                     "desc"=>"avertissement dpassement ", 
                     "unit"=>"A" 
                     ); 
   $trame_def["ADIR3"] = array( 
                     "size"=>3, 
                     "desc"=>"avertissement dpassement ", 
                     "unit"=>"A" 
                     ); 
   $trame_def["IINST1"] = array( 
                     "size"=>3, 
                     "desc"=>"intensit instantane", 
                     "unit"=>"A" 
                     ); 
   $trame_def["IINST2"] = array( 
                     "size"=>3, 
                     "desc"=>"intensit instantane", 
                     "unit"=>"A" 
                     ); 
   $trame_def["IINST3"] = array( 
                     "size"=>3, 
                     "desc"=>"intensit instantane", 
                     "unit"=>"A" 
                     ); 
                      
   $trame_def["ADPS"] = array( 
                     "size"=>3, 
                     "desc"=>"avertissement de dpassement de la puissance souscrite", 
                     "unit"=>"" 
                     ); 
                      
   $trame_def["IMAX1"] = array( 
                     "size"=>3, 
                     "desc"=>"intensit maximale", 
                     "unit"=>"A" 
                     ); 
   $trame_def["IMAX2"] = array( 
                     "size"=>3, 
                     "desc"=>"intensit maximale", 
                     "unit"=>"A" 
                     ); 
   $trame_def["IMAX3"] = array( 
                     "size"=>3, 
                     "desc"=>"intensit maximale", 
                     "unit"=>"A" 
                     ); 
    
   $trame_def["PAPP"] = array( 
                     "size"=>5, 
                     "desc"=>"puissance apparente", 
                     "unit"=>"W" 
                     ); 
    
   $trame_def["HHPHC"] = array( 
                     "size"=>1, 
                     "desc"=>"groupe horaire (Tempo/HC)", 
                     "unit"=>"" 
                     ); 
                      
   $trame_def["MOTDETAT"] = array( 
                     "size"=>6, 
                     "desc"=>"mot d'tat", 
                     "unit"=>"" 
                     ); 
   $trame_def["PMAX"] = array( 
                     "size"=>5, 
                     "desc"=>"puissance maximale tripahse attentee", 
                     "unit"=>"" 
                     );  
   $trame_def["PPOT"] = array( 
                     "size"=>2, 
                     "desc"=>"presence de potentiel", 
                     "unit"=>"" 
                     );  
   /* Fin definition */ 
   return $trame_def; 
} 

/* Verifie le checksum d'un message */ 
function checksum ($etiquette, $valeur) { 
   $sum = 32; // Somme des codes ASCII du message+un espace 
   for ($i=0;$i<strlen($etiquette);$i++) { 
      $sum = $sum + ord($etiquette[$i]); 
   } 
   for ($i=0;$i<strlen($valeur);$i++) { 
      $sum = $sum + ord($valeur[$i]); 
   } 
   $sum = ($sum & 63) + 32; 
   return (chr($sum)); 
} 

/* Verifie la taille des messages */ 
function messize($etiquette) { 
   $trame_def = mesdef(); 
   /* Renvoyer la taille d'une valeur valide */ 
   return $trame_def[$etiquette]["size"]; 
} 

/* Ecrire la liste des etiquettes valides */ 
function etiqlist() { 
   $trame_def = mesdef(); 
   foreach ($trame_def as $etiquette => $definition) { 
      echo("<strong>$etiquette</strong> " . 
          $definition["desc"] . "<br/>\n"); 
   } 
} 

/* Recuperer une trame valide */ 
function teleinfo ($port = "/dev/ttyUSB0") { 
   // Resultat : liste etiquette=>valeur 
   $trame_array = array(); 
    
   // Ouvrir le port en lecture 
   $handle = fopen ($port, "r"); 

   $char = ""; 
   $contents = ""; 
   while (fread($handle, 1) != chr(2)); 

   do { 
      $char = fread($handle, 1); 
      if ($char != chr(2)) $contents .= $char; 
   } while ($char != chr(2)); 


   // Fermer le port 
   fclose ($handle); 

   // Supprimer les caracteres debut/fin de trame 
   $trame = substr($contents,1,-1); 

   // Separer les messages 
   $trame = explode(chr(10).chr(10), $trame); 

   // Verifier les checksum et supprimer les trames incorrectes 
   foreach ($trame as $key=>$message) { 
       
      // Separer l'etiquette, la valeur et le checksum 
      $message = explode (chr(32), $message, 3); 
      list ($etiquette, $valeur, $checksum) = $message; 
    
      // Supprimer le message si incomplet ou incorrect (checksum invalide) 
      if (count($message)<3 || 
         checksum($etiquette, $valeur) != $checksum || 
         messize($etiquette) != strlen($valeur) 
         ) { 
         unset($trame[$key]); 
      } else { 
         // Enregistrer le message dans la liste trame_array 
         $trame_array[$etiquette] = $valeur; 
      } 
   } 
    
   return $trame_array; 
} 
?>
